// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/Hear.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/hear.h"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__HEAR__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__HEAR__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'team'
// Member 'message'
#include "rosidl_runtime_c/string.h"
// Member 'direction'
#include "rosidl_runtime_c/primitives_sequence.h"

// constants for array fields with an upper bound
// direction
enum
{
  rcss3d_agent_msgs__msg__Hear__direction__MAX_SIZE = 1
};

/// Struct defined in msg/Hear in the package rcss3d_agent_msgs.
/**
  * Agent processes are not allowed to communicate with each other directly, but agents may exchange
  * messages via the simulation server. For this purpose agents are equipped with the so-called hear
  * perceptor, which serves as an aural sensor and receives messages shouted by other players.
  *
  * See restrictions: https://gitlab.com/robocup-sim/SimSpark/-/wikis/Perceptors#restrictions
 */
typedef struct rcss3d_agent_msgs__msg__Hear
{
  /// The team of the player who sent the message
  rosidl_runtime_c__String team;
  /// The simulation time at which the given message was heard in seconds.
  float time;
  /// Whether the player is hearing their own words.
  bool self;
  /// Direction of heard message, if the message wasn't the player's own words.
  /// Field has zero size if the "self" field is true.
  rosidl_runtime_c__float__Sequence direction;
  /// Up to 20 characters, which may be taken from the ASCII printing character subset
  /// [0x20, 0x7E] except the white space character and the normal brackets ( and )
  rosidl_runtime_c__String message;
} rcss3d_agent_msgs__msg__Hear;

// Struct for a sequence of rcss3d_agent_msgs__msg__Hear.
typedef struct rcss3d_agent_msgs__msg__Hear__Sequence
{
  rcss3d_agent_msgs__msg__Hear * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__Hear__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__HEAR__STRUCT_H_
